=== debian/changelog ===
liboclock-ocaml (0.3-3) UNRELEASED; urgency=low

  * Split files correctly between base and devel packages

 -- Euan Harris <euan.harris@citrix.com>  Fri, 30 May 2014 12:00:00 +0000

liboclock-ocaml (0.3-2) UNRELEASED; urgency=low

  * Initial package

 -- David Scott <dave.scott@eu.citrix.com>  Wed, 29 May 2013 12:00:00 +0000
